(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["vijay-js"] = {}));
})(this, (function (exports) { 'use strict';

  const SquareRoot=(number)=> {
    return Math.sqrt(number)
  };

  const factorial =(number)=>{

  if (number < 0) {
   return "Error! Factorial for negative number does not exist.";
  }

  // if number is 0
  else if (number === 0) {
   return 1;
  }

  // if number is positive
  else {
    let fact = 1;
    for (i = 1; i <= number; i++) {
      fact *= i;
    }
   return fact;
  }
  };

  const filterData = (data, value) => {
    const expect = [""];
    const lowercasedValue = value.toString().toLowerCase().trim();
    if (lowercasedValue === "") {
      return data;
    } else {
      const filteredData = data.filter((item) => {
        return Object.keys(item).some((key) =>
          expect.includes(key) ? false : item[key]?.toString()?.toLowerCase().includes(lowercasedValue)
        );
      });
      return filteredData;
    }
  };

  function RemoveDuplicate(arr) {
    if (!Array.isArray(arr)) {
      arr = [];
    }
    let theSet = new Set(arr);
    let uniqueArr = [...theSet];
    return uniqueArr;
  }

  const checkPrime =(number)=>{
    let isPrime = true;
    // check if number is equal to 1
    if (number === 1) {
      return("1 is neither prime nor composite number.");
    }

    // check if number is greater than 1
    else if (number > 1) {
      // looping through 2 to number-1
      for (let i = 2; i < number; i++) {
        if (number % i == 0) {
          isPrime = false;
          break;
        }
      }

      if (isPrime) {
        return isPrime;
      } else {
        return isPrime;
      }
    }

    // check if number is less than 1
    else {
      return("The number is not a prime number.");
    }
  };

  const kMeans = (data, k = 1) => {
    const centroids = data.slice(0, k);
    const distances = Array.from({ length: data.length }, () => Array.from({ length: k }, () => 0));
    const classes = Array.from({ length: data.length }, () => -1);
    let itr = true;

    while (itr) {
      itr = false;
      for (let d in data) {
        for (let c = 0; c < k; c++) {
          distances[d][c] = Math.hypot(...Object.keys(data[0]).map((key) => data[d][key] - centroids[c][key]));
        }
        const m = distances[d].indexOf(Math.min(...distances[d]));
        if (classes[d] !== m) itr = true;
        classes[d] = m;
      }

      for (let c = 0; c < k; c++) {
        centroids[c] = Array.from({ length: data[0].length }, () => 0);
        const size = data.reduce((acc, _, d) => {
          if (classes[d] === c) {
            acc++;
            for (let i in data[0]) centroids[c][i] += data[d][i];
          }
          return acc;
        }, 0);
        for (let i in data[0]) {
          centroids[c][i] = parseFloat(Number(centroids[c][i] / size).toFixed(2));
        }
      }
    }

    return classes;
  };

  function ProdConsole(){
    if (process.env.NODE_ENV !== "development"){
      if(console){
        console.log = function () {};
      }
      if (!__DEV__) {
        console.log = () => {};
      }
    }
  }

  function Console(text, color, bg, shadow) {
    var css = "text-shadow: 1px 1px 2px black, 0 0 1em blue, 0 0 0.2em blue;";
    return console.log(`%c${text}, color: ${color},background-color: ${bg}`, shadow ? css : "");
  }

  exports.Console = Console;
  exports.Factorial = factorial;
  exports.ProdConsole = ProdConsole;
  exports.RemoveDuplicate = RemoveDuplicate;
  exports.SquareRoot = SquareRoot;
  exports.checkPrime = checkPrime;
  exports.filterData = filterData;
  exports.kMeans = kMeans;

}));
